# Welcome to BBL Forensic tool !

This is the repository for the project of the *"BBL"* students group, in context of the big data hackathon week at TELECOM Nancy.  
The goal is to detect abnormal processes in logs monitored by [Sysmon](https://docs.microsoft.com/en-us/sysinternals/downloads/sysmon). We propose a simple method to find out many of them, with a sober web interface to make the detection easier and data more understanble.

<img src="resource/screenshots/scores_statistics.png" width="480"><img src="resource/screenshots/process_page.png" width="480">

## How does it work?

We compute **7** metrics for each process in the logs in order to discriminate abnormal records, based on :
- hash frequency
- editor trust factor
- directory frequency
- path depth
- executable run frequency
- number of children
- number of processes launched from a directory

*TODO: explain metrics details, but meanwhile you can take a look at `threat_hunter.py`.*

We are then able to make a global **score**, or to build vectors based on these metrics, and cluster processes using **KMeans**.

## Requirements and installation  
- A **Neo4J** server to put the data in
- **Python** >= 3.6

```shell
$ pip3 install -r requirements.txt
```

Note for Neo4J : import `resource/process2.csv` and `resource/save.csv` from Neo4J  
Then edit `main.py` with your credentials: `(bolt_adress, username, password)` *(you may prefer env. variables)*

## Run
```shell
$ python3 main.py
```
You should be able to access the web interface via http://127.0.0.1:5000.

## Project architecture

**in this directory**  
*(sorry this may be a bit messy but hey, we only had one week)*  
 - `connector.py`: queries to neo4j
 - `statistique.py`: statistics 
 - `threat_hunter.py`: KMeans and heuristic functions

**resources**  
 - `save.csv`: Virus total data
 - `process2.csv`: pre-processed data to import in Neo4J

**gui**  
Folder for the Flask application (web interface).  

**reports**  
Daily reports of the hackathon week.

## Authors:
 - Maxime **B**otreau
 - Fabien **B**ernier
 - Alexander **L**odolo

Special thanks to [Orange Cyberdefense](https://orangecyberdefense.com/) and Jeremy Scion.
