import csv
from statistics import mean, median
import matplotlib.pyplot as plt
import numpy as np

def init():
    with open('resource/process.csv', newline='', encoding='utf-8') as csvfile:
        spamreader = csv.reader(csvfile, delimiter=',')
        d_time = {}
        d_guid = {}
        val = 0
        for row in spamreader:
            if len(d_time.keys()) == 0:
                print(" ".join(row))
            # print(row[-1])
            timestamp = row[-1]
            if timestamp in d_time.keys():
                d_time[timestamp] += 1
            else:
                d_time[timestamp] = 1
            guid = row[4]
            id = row[6]
            dir = row[2]
            process_path = row[7]
            process_hash = row[5]
            if guid in d_guid.keys():
                d_guid[guid] += [[timestamp, id, process_path, dir, process_hash]]
            else:
                d_guid[guid] = [[timestamp, id, process_path, dir, process_hash]]
            val += 1

    n_guid = 0
    for key in d_guid.keys():
        if len(d_guid[key]) != 1:
            print(n_guid, key)
            for elt in d_guid[key]:
                print("   ", elt)
            n_guid += 1
    print("Nombre de time stamp : ", len(d_time.keys()))
    print("Nombre de guid : ", len(d_guid.keys()))
    print("Nombre de lignes : ", val)

def compute_kids():
    with open('resource/process.csv', newline='', encoding='utf-8') as csvfile:
        spamreader = csv.reader(csvfile, delimiter=',')
        d_parent = {}
        for row in spamreader:
            id = row[6]
            parent_guid = row[11]
            if parent_guid in d_parent.keys():
                d_parent[parent_guid] += [id]
            else:
                d_parent[parent_guid] = [id]
    print(len(d_parent.keys()))
    n_kids = []
    max_kids = 0
    max_kids_id = 0
    for key in d_parent.keys():
        n_kids.append(len(d_parent[key]))
        if len(d_parent[key])> max_kids :
            max_kids = len(d_parent[key])
            max_kids_id = key
    print(max_kids_id, max_kids)
    print(get_process(max_kids_id))


def get_process(process_id):
    with open('resource/process.csv', newline='', encoding='utf-8') as csvfile:
        spamreader = csv.reader(csvfile, delimiter=',')
        d_parent = {}
        ret = []
        for row in spamreader:
            id = row[6]
            if id == process_id:
                ret = row
        return ret

# compute_kids()
# init()

# process process_company process_current_directory process_exec process_guid process_hash process_id
# process_path parent_process parent_process_exec parent_process_guid parent_process_id parent_process_path
# CommandLine ComputerName _time
def compute_path_length():
    with open('resource/process.csv', newline='', encoding='utf-8') as csvfile:
        spamreader = csv.DictReader(csvfile, delimiter=',')
        sizes = []
        for row in spamreader:
            size = len(row["process_path"].split("\\"))
            sizes.append(size - 2)
            pass
        print(max(sizes))
        print(min(sizes))
        print(mean(sizes))
        arr = plt.hist(sizes, bins=9)
        for i in range(9):
            plt.text(arr[1][i], arr[0][i], str(arr[0][i]))
        plt.xlabel("Process Path Length")
        plt.ylabel("Value in the dataset")
        plt.show()
# compute_path_length()

def display_histo(data, title):
    density, bins, _ = plt.hist(data, density=True, bins='auto')
    count, _ = np.histogram(data, bins)
    for x, y, num in zip(bins, density, count):
        if num != 0:
            plt.text(x, y + 0.05, num, fontsize=10, rotation=-90)  # x,y,str
    plt.show()

def make_histogram(data):
    dict = {}
    for d in data:
        if d in dict:
            dict[d] += 1
        else:
            dict[d] = 1
    #for elt in sorted(dict):
    #    print(str(elt) + " : " + str(dict[elt]))
    return dict

def print_stat(data):
    print("    Nombre de données :", len(data))
    print("    Valeur Minimale :", min(data))
    print("    Valeur Maximale :", max(data))
    print("    Valeur Moyenne :", mean(data))
    print("    Valeur Mediane :", median(data))
    display_histo(data, "")

